---
title: '<tr>: The Table Row element'
slug: Web/HTML/Element/tr
tags:
  - Element
  - HTML
  - HTML tabular data
  - Reference
  - Tables
  - Web
  - tag
  - tr
  - tr tag
---
<div>{{HTMLRef}}</div>

<p><span class="seoSummary">The <strong>HTML <code>&lt;tr&gt;</code> element</strong> defines a row of cells in a table. The row's cells can then be established using a mix of {{HTMLElement("td")}} (data cell) and {{HTMLElement("th")}} (header cell) elements.</span></p>

<div>{{EmbedInteractiveExample("pages/tabbed/tr.html","tabbed-taller")}}</div>

<p class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples </a> and send us a pull request.</p>

<p>To provide additional control over how cells fit into (or span across) columns, both <code>&lt;th&gt;</code> and <code>&lt;td&gt;</code> support the {{htmlattrxref("colspan", "td")}} attribute, which lets you specify how many columns wide the cell should be, with the default being 1. Similarly, you can use the {{htmlattrxref("rowspan", "td")}} attribute on cells to indicate they should span more than one table row.</p>

<p>This can take a little practice to get right when building your tables. We have some {{anch("Examples", "examples")}} below, but for more examples and an in-depth tutorial, see the <a href="/en-US/docs/Learn/HTML/Tables">HTML tables</a> series in our <a href="/en-US/docs/Learn">Learn web development</a> area, where you'll learn how to use the table elements and their attributes to get just the right layout and formatting for your tabular data.</p>

<h2 id="Attributes">Attributes</h2>

<p>This element includes the <a href="/en-US/docs/Web/HTML/Global_attributes">global attributes</a>. There are also several {{anch("deprecated attributes")}}, which you should avoid but may need to know when reading older code.</p>

<h3 id="Deprecated_attributes">Deprecated attributes</h3>

<p>The following attributes may still be implemented in browsers but are no longer part of the HTML specification and may be missing or may not work as expected. They should be avoided.</p>

<dl>
 <dt>{{HTMLAttrDef("align")}}{{Obsolete_Inline("HTML5")}}</dt>
 <dd>A {{DOMxRef("DOMString")}} which specifies how the cell's context should be aligned horizontally within the cells in the row; this is shorthand for using <code>align</code> on every cell in the row individually. Possible values are:
 <dl>
  <dt><code>left</code></dt>
  <dd>Align the content of each cell at its left edge.</dd>
  <dt><code>center</code></dt>
  <dd>Center the contents of each cell between their left and right edges.</dd>
  <dt><code>right</code></dt>
  <dd>Align the content of each cell at its right edge.</dd>
  <dt><code>justify</code></dt>
  <dd>Widen whitespaces within the text of each cell so that the text fills the full width of each cell (full justification).</dd>
  <dt><code>char</code></dt>
  <dd>Align each cell in the row on a specific character (such that each row in the column that is configured this way will horizontally align its cells on that character). This uses the {{htmlattrxref("char", "tr")}} and {{htmlattrxref("charoff", "tr")}} to establish the alignment character (typically "." or "," when aligning numerical data) and the number of characters that should follow the alignment character. This alignment type was never widely supported.</dd>
 </dl>

 <p>If no value is expressly set for <code>align</code>, the parent node's value is inherited.</p>

 <div class="note">
 <p>Instead of using the obsolete <code>align</code> attribute, you should instead use the CSS {{CSSxRef("text-align")}} property to establish <code>left</code>, <code>center</code>, <code>right</code>, or <code>justify</code> alignment for the row's cells. To apply character-based alignment, set the CSS {{CSSxRef("text-align")}} property to the alignment character (such as <code>"."</code> or <code>","</code>).</p>
 </div>
 </dd>
</dl>

<dl>
 <dt>{{HTMLAttrDef("bgcolor")}}{{Obsolete_Inline("HTML5")}}</dt>
 <dd>
 <p>A {{DOMxRef("DOMString")}} specifying a color to apply to the backgrounds of each of the row's cells. This can be either an <a href="/en-US/docs/Web/CSS/color_value#rgb()">hexadecimal <code>#RRGGBB</code> or <code>#RGB</code> value</a> or a <a href="/en-US/docs/Web/CSS/color_value#Color_keywords">color keyword</a>. Omitting the attribute or setting it to <code>null</code> in JavaScript causes the row's cells to inherit the row's parent element's background color.</p>

 <div class="note">
 <p>The {{HTMLElement("tr")}} element should be styled using <a href="/en-US/docs/Web/CSS">CSS</a>. To give a similar effect as the <code>bgcolor</code> attribute, use the <a href="/en-US/docs/Web/CSS">CSS</a> property {{CSSxRef("background-color")}}.</p>
 </div>
 </dd>
</dl>

<dl>
 <dt>{{HTMLAttrDef("char")}}{{Obsolete_Inline("HTML5")}}</dt>
 <dd>
 <p>A {{DOMxRef("DOMString")}} which sets the character to align the cells in each of the row's columns on (each row's centering that uses the same character gets aligned with others using the same character . Typical values for this include a period (<code>"."</code>) or comma (<code>","</code>) when attempting to align numbers or monetary values. If {{htmlattrxref("align", "tr")}} is not set to <code>char</code>, this attribute is ignored.</p>

 <div class="note">
 <p>This attribute is not only obsolete, but was rarely implemented anyway. To achieve the same effect as the {{htmlattrxref("char", "tr")}} attribute, set the CSS {{CSSxRef("text-align")}} property to the same string you would specify for the <code>char</code> property, such as <code>text-align: "."</code>.</p>
 </div>
 </dd>
</dl>

<dl>
 <dt>{{HTMLAttrDef("charoff")}}{{Obsolete_Inline("HTML5")}}</dt>
 <dd>
 <p>A {{DOMxRef("DOMString")}} indicating the number of characters on the tail end of the column's data should be displayed after the alignment character specified by the <code>char</code> attribute. For example, when displaying money values for currencies that use hundredths of a unit (such as the dollar, which is divided into 100 cents), you would typically specify a value of 2, so that in tandem with <code>char</code> being set to <code>"."</code>, the values in a column would be cleanly aligned on the decimal points, with the number of cents properly displayed to the right of the decimal point.</p>

 <div class="note">
 <p>This attribute is obsolete, and was never widely supported anyway.</p>
 </div>
 </dd>
</dl>

<dl>
 <dt>{{HTMLAttrDef("valign")}}{{Obsolete_Inline("HTML5")}}</dt>
 <dd>
 <p>A {{DOMxRef("DOMString")}} specifying the vertical alignment of the text within each cell in the row. Possible values for this attribute are:</p>

 <dl>
  <dt><code>baseline</code></dt>
  <dd>Aligns each cell's content text as closely as possible to the bottom of the cell, handling alignment of different fonts and font sizes by aligning the characters along the {{interwiki("wikipedia", "baseline")}} of the font(s) used in the row. If all of the characters in the row are the same size, the effect is the same as <code>bottom</code>.</dd>
  <dt><code>bottom</code>,</dt>
  <dd>Draws the text in each of the row's cells as closely as possible to the bottom edge of those cells.</dd>
  <dt><code>middle</code></dt>
  <dd>Each cell's text is vertically centered.</dd>
  <dt><code>top</code></dt>
  <dd>Each cell's text is drawn as closely as possible to the top edge of the containing cell.</dd>
 </dl>

 <div class="note">
 <p>Don't use the obsolete <code>valign</code> attribute. Instead, add the CSS {{CSSxRef("vertical-align")}} property to the row.</p>
 </div>
 </dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>See {{HTMLElement("table")}} for examples on <code>&lt;tr&gt;</code>.</p>

<h3 id="Basic_example">Basic example</h3>

<p>This simple example shows a table listing people's names along with various information about membership in a club or service.</p>

<h4 id="HTML">HTML</h4>

<p>This HTML demonstrates the most basic structure of a table. There are no groups, no cells that span multiple rows or columns, no captions, and only the most basic styling to create lines around the components of the table for something resembling clarity.</p>

<p>There are just four rows (including one header row), each with four columns (including one header column). Not even the table section elements are used; instead, the browser is allowed to determine this automatically. We'll add {{HTMLElement("thead")}}, {{HTMLElement("tbody")}}, and {{HTMLElement("tfoot")}} in the next example.</p>

<pre class="brush: html notranslate">&lt;table&gt;
  &lt;tr&gt;
    &lt;th&gt;Name&lt;/th&gt;
    &lt;th&gt;ID&lt;/th&gt;
    &lt;th&gt;Member Since&lt;/th&gt;
    &lt;th&gt;Balance&lt;/th&gt;
  &lt;/tr&gt;
  &lt;tr&gt;
    &lt;td&gt;Margaret Nguyen&lt;/td&gt;
    &lt;td&gt;427311&lt;/td&gt;
    &lt;td&gt;&lt;time datetime="2010-06-03"&gt;June 3, 2010&lt;/time&gt;&lt;/td&gt;
    &lt;td&gt;0.00&lt;/td&gt;
  &lt;/tr&gt;
  &lt;tr&gt;
    &lt;td&gt;Edvard Galinski&lt;/td&gt;
    &lt;td&gt;533175&lt;/td&gt;
    &lt;td&gt;&lt;time datetime="2011-01-13"&gt;January 13, 2011&lt;/time&gt;&lt;/td&gt;
    &lt;td&gt;37.00&lt;/td&gt;
  &lt;/tr&gt;
  &lt;tr&gt;
    &lt;td&gt;Hoshi Nakamura&lt;/td&gt;
    &lt;td&gt;601942&lt;/td&gt;
    &lt;td&gt;&lt;time datetime="2012-07-23"&gt;July 23, 2012&lt;/time&gt;&lt;/td&gt;
    &lt;td&gt;15.00&lt;/td&gt;
  &lt;/tr&gt;
&lt;/table&gt;</pre>

<h4 id="CSS">CSS</h4>

<p>This simple CSS just adds a solid black border around the table and around each of its cells, including those specified using both {{HTMLElement("th")}} and {{HTMLElement("td")}}. That way, both header and data cells are easily demarcated.</p>

<pre class="brush: css notranslate">table {
  border: 1px solid black;
}

th, td {
  border: 1px solid black;
}</pre>

<h4 id="Result">Result</h4>

<p>{{EmbedLiveSample("Basic_example", 500, 125)}}</p>

<h3 id="Row_and_column_spanning">Row and column spanning</h3>

<p>Now, let's introduce another column that shows the date the user's membership ended, along with a super-heading above the "joined" and "canceled" dates called "Membership Dates". This involves adding both row and column spans to the table, so that the heading cells can wind up in the right places.</p>

<h4 id="Result_2">Result</h4>

<p>Let's actually look at the output first this time:</p>

<p>{{EmbedLiveSample("Row_and_column_spanning", 500, 150)}}</p>

<p>Notice how the heading area here is actually two rows, one with "Name", "ID", "Membership Dates", and "Balance" headings, and the other with "Joined" and "Canceled", which are sub-headings below "Membership Dates". This is accomplished by:</p>

<ul>
 <li>Having the first row's "Name", "ID", and "Balance" heading cells span two rows using the {{htmlattrxref("rowspan")}} attribute, making them each be two rows tall.</li>
 <li>Having the first row's "Membership Dates" heading cell span two columns using the {{htmlattrxref("colspan")}} attribute, which causes this heading to actually be two columns wide.</li>
 <li>Having a second row of {{HTMLElement("th")}} elements that contains only the "Joined" and "Canceled" headings. Because the other columns are already occupied by first-row cells that span into the second row, these wind up correctly positioned under the "Membership Dates" heading.</li>
</ul>

<h4 id="HTML_2">HTML</h4>

<p>The HTML is similar to the previous example's, except for the addition of the new column in each data row, and the changes to the header. Those changes make the HTML look like this:</p>

<pre class="brush: html notranslate">&lt;table&gt;
  &lt;tr&gt;
    &lt;th rowspan="2"&gt;Name&lt;/th&gt;
    &lt;th rowspan="2"&gt;ID&lt;/th&gt;
    &lt;th colspan="2"&gt;Membership Dates&lt;/th&gt;
    &lt;th rowspan="2"&gt;Balance&lt;/th&gt;
  &lt;/tr&gt;
  &lt;tr&gt;
    &lt;th&gt;Joined&lt;/th&gt;
    &lt;th&gt;Canceled&lt;/th&gt;
  &lt;/tr&gt;
  &lt;tr&gt;
    &lt;th&gt;Margaret Nguyen&lt;/td&gt;
    &lt;td&gt;427311&lt;/td&gt;
    &lt;td&gt;&lt;time datetime="2010-06-03"&gt;June 3, 2010&lt;/time&gt;&lt;/td&gt;
    &lt;td&gt;n/a&lt;/td&gt;
    &lt;td&gt;0.00&lt;/td&gt;
  &lt;/tr&gt;
  &lt;tr&gt;
    &lt;th&gt;Edvard Galinski&lt;/td&gt;
    &lt;td&gt;533175&lt;/td&gt;
    &lt;td&gt;&lt;time datetime="2011-01-13"&gt;January 13, 2011&lt;/time&gt;&lt;/td&gt;
    &lt;td&gt;&lt;time datetime="2017-04-08"&gt;April 8, 2017&lt;/time&gt;&lt;/td&gt;
    &lt;td&gt;37.00&lt;/td&gt;
  &lt;/tr&gt;
  &lt;tr&gt;
    &lt;th&gt;Hoshi Nakamura&lt;/td&gt;
    &lt;td&gt;601942&lt;/td&gt;
    &lt;td&gt;&lt;time datetime="2012-07-23"&gt;July 23, 2012&lt;/time&gt;&lt;/td&gt;
    &lt;td&gt;n/a&lt;/td&gt;
    &lt;td&gt;15.00&lt;/td&gt;
  &lt;/tr&gt;
&lt;/table&gt;</pre>

<p>The differences that matter here—for the purposes of discussing row and column spans—are in the first few lines of the code above. Note the use of <code>rowspan</code> on to make the "Name", "ID", and "Balance" headers occupy two rows instead of just one, and the use of <code>colspan</code> to make the "Membership Dates" header cell span across two columns.</p>

<p>The CSS is unchanged from before.</p>

<div class="hidden">
<pre class="brush: css notranslate">table {
  border: 1px solid black;
}

th, td {
  border: 1px solid black;
}</pre>
</div>

<h3 id="Explicitly_specifying_table_content_groups">Explicitly specifying table content groups</h3>

<p>Before really getting into styling this table, let's take a moment to add row and column groups to help make our CSS easier.</p>

<h4 id="HTML_3">HTML</h4>

<p>The HTML is where the action is here, and the action is pretty simple.</p>

<pre class="brush: html notranslate">&lt;table&gt;
  &lt;thead&gt;
    &lt;tr&gt;
      &lt;th rowspan="2"&gt;Name&lt;/th&gt;
      &lt;th rowspan="2"&gt;ID&lt;/th&gt;
      &lt;th colspan="2"&gt;Membership Dates&lt;/th&gt;
      &lt;th rowspan="2"&gt;Balance&lt;/th&gt;
    &lt;/tr&gt;
    &lt;tr&gt;
      &lt;th&gt;Joined&lt;/th&gt;
      &lt;th&gt;Canceled&lt;/th&gt;
    &lt;/tr&gt;
  &lt;/thead&gt;
  &lt;tbody&gt;
    &lt;tr&gt;
      &lt;th scope="row"&gt;Margaret Nguyen&lt;/td&gt;
      &lt;td&gt;427311&lt;/td&gt;
      &lt;td&gt;&lt;time datetime="2010-06-03"&gt;June 3, 2010&lt;/time&gt;&lt;/td&gt;
      &lt;td&gt;n/a&lt;/td&gt;
      &lt;td&gt;0.00&lt;/td&gt;
    &lt;/tr&gt;
    &lt;tr&gt;
      &lt;th scope="row"&gt;Edvard Galinski&lt;/td&gt;
      &lt;td&gt;533175&lt;/td&gt;
      &lt;td&gt;&lt;time datetime="2011-01-13"&gt;January 13, 2011&lt;/time&gt;&lt;/td&gt;
      &lt;td&gt;&lt;time datetime="2017-04-08"&gt;April 8, 2017&lt;/time&gt;&lt;/td&gt;
      &lt;td&gt;37.00&lt;/td&gt;
    &lt;/tr&gt;
    &lt;tr&gt;
      &lt;th scope="row"&gt;Hoshi Nakamura&lt;/td&gt;
      &lt;td&gt;601942&lt;/td&gt;
      &lt;td&gt;&lt;time datetime="2012-07-23"&gt;July 23, 2012&lt;/time&gt;&lt;/td&gt;
      &lt;td&gt;n/a&lt;/td&gt;
      &lt;td&gt;15.00&lt;/td&gt;
    &lt;/tr&gt;
  &lt;/tbody&gt;
&lt;/table&gt;</pre>

<p>The differences that matter here—for the purposes of discussing row and column spans—are in the first few lines of the code above. Note the use of <code>rowspan</code> on to make the "Name", "ID", and "Balance" headers occupy two rows instead of just one, and the use of <code>colspan</code> to make the "Membership Dates" header cell span across two columns.</p>

<p>Once again, we haven't touched the CSS.</p>

<div class="hidden">
<pre class="brush: css notranslate">table {
  border: 1px solid black;
}

th, td {
  border: 1px solid black;
}</pre>
</div>

<h4 id="Result_3">Result</h4>

<p>The output is entirely unchanged, despite the addition of useful contextual information under the hood:</p>

<p>{{EmbedLiveSample("Explicitly_specifying_table_content_groups", 500, 150)}}</p>

<h3 id="Basic_styling">Basic styling</h3>

<p>As is the case with all parts of a table, you can change the appearance of a table row and its contents using CSS. Any styles applied to the <code>&lt;tr&gt;</code> element will affect the cells within the row unless overridden by styles applied to those cells.</p>

<p>Let's apply a basic style to the table to adjust the typeface being used, and add a background color to the header row.</p>

<h4 id="Result_4">Result</h4>

<p>Again, let's take a look at the result first.</p>

<p>{{EmbedLiveSample("Basic_styling", 500, 200)}}</p>

<div class="hidden">
<pre class="brush: html notranslate">&lt;table&gt;
  &lt;thead&gt;
    &lt;tr&gt;
      &lt;th rowspan="2"&gt;Name&lt;/th&gt;
      &lt;th rowspan="2"&gt;ID&lt;/th&gt;
      &lt;th colspan="2"&gt;Membership Dates&lt;/th&gt;
      &lt;th rowspan="2"&gt;Balance&lt;/th&gt;
    &lt;/tr&gt;
    &lt;tr&gt;
      &lt;th&gt;Joined&lt;/th&gt;
      &lt;th&gt;Canceled&lt;/th&gt;
    &lt;/tr&gt;
  &lt;/thead&gt;
  &lt;tbody&gt;
    &lt;tr&gt;
      &lt;th scope="row"&gt;Margaret Nguyen&lt;/td&gt;
      &lt;td&gt;427311&lt;/td&gt;
      &lt;td&gt;&lt;time datetime="2010-06-03"&gt;June 3, 2010&lt;/time&gt;&lt;/td&gt;
      &lt;td&gt;n/a&lt;/td&gt;
      &lt;td&gt;0.00&lt;/td&gt;
    &lt;/tr&gt;
    &lt;tr&gt;
      &lt;th scope="row"&gt;Edvard Galinski&lt;/td&gt;
      &lt;td&gt;533175&lt;/td&gt;
      &lt;td&gt;&lt;time datetime="2011-01-13"&gt;January 13, 2011&lt;/time&gt;&lt;/td&gt;
      &lt;td&gt;&lt;time datetime="2017-04-08"&gt;April 8, 2017&lt;/time&gt;&lt;/td&gt;
      &lt;td&gt;37.00&lt;/td&gt;
    &lt;/tr&gt;
    &lt;tr&gt;
      &lt;th scope="row"&gt;Hoshi Nakamura&lt;/td&gt;
      &lt;td&gt;601942&lt;/td&gt;
      &lt;td&gt;&lt;time datetime="2012-07-23"&gt;July 23, 2012&lt;/time&gt;&lt;/td&gt;
      &lt;td&gt;n/a&lt;/td&gt;
      &lt;td&gt;15.00&lt;/td&gt;
    &lt;/tr&gt;
  &lt;/tbody&gt;
&lt;/table&gt;</pre>
</div>

<h4 id="CSS_2">CSS</h4>

<p>This time, the HTML is unchanged, so let's dive right into the CSS.</p>

<pre class="brush: css notranslate">table {
  border: 1px solid black;
  font: 16px "Open Sans", Helvetica, Arial, sans-serif;
}

thead &gt; tr {
  background-color: rgb(228, 240, 245);
}

th, td {
  border: 1px solid black;
  padding:4px 6px;
}
</pre>

<p>While we add a {{CSSxRef("font")}} property to the {{HTMLElement("table")}} element here to set a more visually-appealing typeface (or an abominable sans-serif typeface, depending on your personal opinion), the interesting part is the second style here, where we style <code>&lt;tr&gt;</code> elements located within the {{HTMLElement("thead")}} so they have a light blue background color. This is a way to quickly apply a background color to all of the cells in the heading area at once.</p>

<p>This does <em>not</em> affect the style of the {{HTMLElement("th")}} elements in the first column, though, where we treat the member names as a row heading.</p>

<h3 id="Advanced_styling">Advanced styling</h3>

<p>Now we'll go all-out, with styles on rows in the header and body areas both, including alternating row colors, cells with different colors depending on position within a row, and so forth.</p>

<h4 id="Result_5">Result</h4>

<p>Here's what the final table will look like:</p>

<p>{{EmbedLiveSample("Advanced_styling", 500, 200)}}</p>

<p>There is no change to the HTML again. See what proper preparation of your HTML can do for you?</p>

<div class="hidden">
<pre class="brush: html notranslate">&lt;table&gt;
  &lt;thead&gt;
    &lt;tr&gt;
      &lt;th rowspan="2"&gt;Name&lt;/th&gt;
      &lt;th rowspan="2"&gt;ID&lt;/th&gt;
      &lt;th colspan="2"&gt;Membership Dates&lt;/th&gt;
      &lt;th rowspan="2"&gt;Balance&lt;/th&gt;
    &lt;/tr&gt;
    &lt;tr&gt;
      &lt;th&gt;Joined&lt;/th&gt;
      &lt;th&gt;Canceled&lt;/th&gt;
    &lt;/tr&gt;
  &lt;/thead&gt;
  &lt;tbody&gt;
    &lt;tr&gt;
      &lt;th scope="row"&gt;Margaret Nguyen&lt;/td&gt;
      &lt;td&gt;427311&lt;/td&gt;
      &lt;td&gt;&lt;time datetime="2010-06-03"&gt;June 3, 2010&lt;/time&gt;&lt;/td&gt;
      &lt;td&gt;n/a&lt;/td&gt;
      &lt;td&gt;0.00&lt;/td&gt;
    &lt;/tr&gt;
    &lt;tr&gt;
      &lt;th scope="row"&gt;Edvard Galinski&lt;/td&gt;
      &lt;td&gt;533175&lt;/td&gt;
      &lt;td&gt;&lt;time datetime="2011-01-13"&gt;January 13, 2011&lt;/time&gt;&lt;/td&gt;
      &lt;td&gt;&lt;time datetime="2017-04-08"&gt;April 8, 2017&lt;/time&gt;&lt;/td&gt;
      &lt;td&gt;37.00&lt;/td&gt;
    &lt;/tr&gt;
    &lt;tr&gt;
      &lt;th scope="row"&gt;Hoshi Nakamura&lt;/td&gt;
      &lt;td&gt;601942&lt;/td&gt;
      &lt;td&gt;&lt;time datetime="2012-07-23"&gt;July 23, 2012&lt;/time&gt;&lt;/td&gt;
      &lt;td&gt;n/a&lt;/td&gt;
      &lt;td&gt;15.00&lt;/td&gt;
    &lt;/tr&gt;
  &lt;/tbody&gt;
&lt;/table&gt;</pre>
</div>

<h4 id="CSS_3">CSS</h4>

<p>The CSS is much more involved this time. It's not complicated, but there's a lot going on. Let's break it down.</p>

<h5 id="The_table_and_base_styles">The table and base styles</h5>

<pre class="brush: css notranslate">table {
  border: 1px solid black;
  font: 16px "Open Sans", Helvetica, Arial, sans-serif;
  border-spacing: 0;
  border-collapse: collapse;
}</pre>

<p>Here we've added the {{CSSxRef("border-spacing")}} and {{CSSxRef("border-collapse")}} properties to eliminate spacing between cells and collapse borders that touch one another to be a single border instead of winding up with double borders.</p>

<pre class="brush: css notranslate">th, td {
  border: 1px solid black;
  padding:4px 6px;
}

th {
  vertical-align: bottom;
}</pre>

<p>And here are the default styles for all table cells. Now let's customize!</p>

<h5 id="The_top_header_overall">The top header: overall</h5>

<p>We're going to look at the top header in two pieces. First, the overall styling of the header:</p>

<pre class="brush: css notranslate">thead &gt; tr {
  background-color: rgb(228, 240, 245);
}

thead &gt; tr:nth-of-type(2) {
  border-bottom: 2px solid black;
}</pre>

<p>This sets the background color of all <code>&lt;tr&gt;</code> elements in the table's heading (as specified using {{HTMLElement("thead")}}). Then we set the bottom border of the top header to be a two-pixel wide line. Notice, however, that we're using the {{CSSxRef(":nth-of-type")}} selector to apply {{CSSxRef("border-bottom")}} to the <em>second</em> row in the heading. Why? Because the heading is made of two rows that are spanned by some of the cells. That means there are actually two rows there; applying the style to the first row would not give us the expected result.</p>

<h5 id="The_Joined_and_Canceled_headers">The "Joined" and "Canceled" headers</h5>

<p>Let's style these two header cells with green and red hues to represent the "good" of a new member and the "bummer" of a canceled membership.</p>

<pre class="brush: css notranslate">thead &gt; tr:last-of-type &gt; th:nth-of-type(1) {
  background-color: rgb(225, 255, 225);
}

thead &gt; tr:last-of-type &gt; th:nth-of-type(2) {
  background-color: rgb(255, 225, 225);
}</pre>

<p>Here we dig into the last row of the table's header block and give the first header cell in it (the "Joined" header) a greenish color, and the second header cell in it (the "Canceled" header) a reddish hue.</p>

<h5 id="Color_every_body_other_row_differently">Color every body other row differently</h5>

<p>It's common to help improve readability of table data by alternating row colors. Let's add a bit of color to every even row:</p>

<pre class="brush: css notranslate">tbody &gt; tr:nth-of-type(even) {
  background-color: rgb(237, 238, 242);
}</pre>

<h5 id="Give_the_left-side_header_some_style">Give the left-side header some style</h5>

<p>Since we want the first column to stand out as well, we'll add some custom styling here, too.</p>

<pre class="brush: css notranslate">tbody &gt; tr &gt; th:first-of-type {
  text-align: left;
  background-color: rgb(225, 229, 244);
}</pre>

<p>This styles the first header cell in each row of the table's body with {{CSSxRef("text-align")}} to left-justify the member names, and with a somewhat different background color.</p>

<h5 id="Justify_the_balances">Justify the balances</h5>

<p>Finally, since it's standard practice to right-justify currency values in tables, let's do that here.</p>

<pre class="brush: css notranslate">tbody &gt; tr &gt; td:last-of-type {
  text-align:right;
}</pre>

<p>This just sets the CSS {{CSSxRef("text-align")}} property for the last {{HTMLElement("td")}} in each body row to <code>"right"</code>.</p>

<h2 id="Technical_summary">Technical summary</h2>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row"><a href="/en-US/docs/Web/Guide/HTML/Content_categories">Content categories</a></th>
   <td>None</td>
  </tr>
  <tr>
   <th scope="row">Permitted content</th>
   <td>Zero or more {{HTMLElement("td")}} and/or {{HTMLElement("th")}} elements; {{Glossary("script-supporting element", "script-supporting elements")}} ({{HTMLElement("script")}} and {{HTMLElement("template")}}) are also allowed</td>
  </tr>
  <tr>
   <th scope="row">Tag omission</th>
   <td>Start tag is mandatory. End tag may be omitted if the {{HTMLElement("tr")}} element is immediately followed by a {{HTMLElement("tr")}} element, or if the row is the last element in its parent table group ({{HTMLElement("thead")}}, {{HTMLElement("tbody")}} or {{HTMLElement("tfoot")}}) element</td>
  </tr>
  <tr>
   <th scope="row">Permitted parents</th>
   <td>{{HTMLElement("table")}} (only if the table has no child {{HTMLElement("tbody")}} element, and even then only after any {{HTMLElement("caption")}}, {{HTMLElement("colgroup")}}, and {{HTMLElement("thead")}} elements); otherwise, the parent must be {{HTMLElement("thead")}}, {{HTMLElement("tbody")}} or {{HTMLElement("tfoot")}}</td>
  </tr>
  <tr>
   <th scope="row">Implicit ARIA role</th>
   <td><code><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Row_Role">row</a></code></td>
  </tr>
  <tr>
   <th scope="row">Permitted ARIA roles</th>
   <td>Any</td>
  </tr>
  <tr>
   <th scope="row">DOM interface</th>
   <td>{{DOMxRef("HTMLTableRowElement")}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('HTML WHATWG','tables.html#the-tr-element','tr element')}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td>The WHATWG Living Standard</td>
  </tr>
  <tr>
   <td>{{SpecName('HTML5 W3C','tabular-data.html#the-tr-element','tr element')}}</td>
   <td>{{Spec2('HTML5 W3C')}}</td>
   <td>W3C HTML5</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("html.elements.tr")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Learn/HTML/Tables">Learning area: HTML tables</a>: An introduction to using tables, including <code>&lt;tr&gt;</code>.</li>
 <li>{{DOMxRef("HTMLTableRowElement")}}: the interface on which <code>&lt;tr&gt;</code> is based.</li>
 <li>Other table-related elements:
  <ul>
   <li>{{HTMLElement("table")}}, {{HTMLElement("thead")}}, {{HTMLElement("tbody")}}, {{HTMLElement("tfoot")}}, {{HTMLElement("td")}}, {{HTMLElement("th")}},{{HTMLElement("caption")}}, {{HTMLElement("col")}}, and {{HTMLElement("colgroup")}}</li>
  </ul>
 </li>
</ul>
